Lattice Grid Buy a licence

demo D230

An SPC study: control, range, capability

A drifting process with limits fixed on the first thirty readings, so the drift breaks a rule rather than being absorbed

chart type: control · movingRange · capability

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid, createStat } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/charts.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'n', title: '#', type: 'number', layout: { width: 80 } },
    // The spec declares the tolerance; capability and the control limits read it.
    { field: 'bore', title: 'Bore', type: 'millimetres', spec: { lower: 9.95, upper: 10.05, target: 10 } },
  ];

  const rows = [/* one process over time, drifting up after the thirtieth reading */];

  function App() {
    const gridRef = React.useRef(null);

    React.useEffect(() => {
      const grid = gridRef.current.grid;

      // Three figures read from the live grid: Cpk against the tolerance, the
      // mean bore, and the count. baseline fixes the control limits on the first
      // thirty readings, so the later drift breaks a rule.
      createStat({ grid, container: '#cpk', title: 'Cpk',
        value: (g) => g.statistics.capability('bore', { rules: 'nelson', baseline: 30 })?.cpk,
        goodWhen: 'up', baseline: 1.33, decimals: 2, footer: '1.33 is the usual floor' });
      createStat({ grid, container: '#mean', title: 'Mean bore', of: 'bore', fn: 'avg' });
      createStat({ grid, container: '#count', title: 'Readings', fn: 'count', footer: 'the first 30 set the limits' });

      // Control, moving range and capability, all from the one declared tolerance.
      createChart({ grid, container: '#control', type: 'control', y: 'bore', baseline: 30, rules: 'nelson',
        title: 'Control chart, limits fixed on the first 30 readings' });
      createChart({ grid, container: '#mr', type: 'movingRange', y: 'bore', title: 'Moving range' });
      createChart({ grid, container: '#cap', type: 'capability', y: 'bore', title: 'Capability against the tolerance' });
    }, []);

    return (
      <>
        <div style={{ display: 'grid', gridTemplateColumns: 'repeat(3, 1fr)', gap: '12px' }}>
          <div id="cpk" />
          <div id="mean" />
          <div id="count" />
        </div>
        <div id="control" style={{ height: '220px', marginTop: '14px' }} />
        <div style={{ display: 'grid', gridTemplateColumns: '1fr 1fr', gap: '12px', marginTop: '14px' }}>
          <div id="mr" style={{ height: '200px' }} />
          <div id="cap" style={{ height: '200px' }} />
        </div>
        <LatticeGrid
          ref={gridRef}
          rowKey="id"
          toolPanel={{ side: 'left', panels: ['columns', 'statistics'] }}
          columns={columns}
          rows={rows}
          style={{ height: '320px', marginTop: '14px' }}
        />
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Lattice Grid Buy a licence

demo D230

An SPC study: control, range, capability

A drifting process with limits fixed on the first thirty readings, so the drift breaks a rule rather than being absorbed

chart type: control · movingRange · capability

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid, createStat } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'n', title: '#', type: 'number', layout: { width: 80 } },
  // The spec declares the tolerance; capability and the control limits read it.
  { field: 'bore', title: 'Bore', type: 'millimetres', spec: { lower: 9.95, upper: 10.05, target: 10 } },
];

const rows = [/* one process over time, drifting up after the thirtieth reading */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<div style="display:grid;grid-template-columns:repeat(3, 1fr);gap:12px">' +
    '<div id="cpk"></div>' +
    '<div id="mean"></div>' +
    '<div id="count"></div>' +
    '</div>' +
    '<div id="control" style="height:220px;margin-top:14px"></div>' +
    '<div style="display:grid;grid-template-columns:1fr 1fr;gap:12px;margin-top:14px">' +
    '<div id="mr" style="height:200px"></div>' +
    '<div id="cap" style="height:200px"></div>' +
    '</div>' +
    '<lattice-grid [config]="grid" style="display:block;height:320px;margin-top:14px"></lattice-grid>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  grid = {
    rowKey: 'id',
    toolPanel: { side: 'left', panels: ['columns', 'statistics'] },
    columns: columns,
    rows: rows,
  };

  ngAfterViewInit() {
    const grid = this.gridRef.grid;
    // Three figures read from the live grid: Cpk against the tolerance, the
    // mean bore, and the count. baseline fixes the control limits on the first
    // thirty readings, so the later drift breaks a rule.
    createStat({ grid, container: '#cpk', title: 'Cpk',
      value: (g) => g.statistics.capability('bore', { rules: 'nelson', baseline: 30 })?.cpk,
      goodWhen: 'up', baseline: 1.33, decimals: 2, footer: '1.33 is the usual floor' });
    createStat({ grid, container: '#mean', title: 'Mean bore', of: 'bore', fn: 'avg' });
    createStat({ grid, container: '#count', title: 'Readings', fn: 'count', footer: 'the first 30 set the limits' });

    // Control, moving range and capability, all from the one declared tolerance.
    createChart({ grid, container: '#control', type: 'control', y: 'bore', baseline: 30, rules: 'nelson',
      title: 'Control chart, limits fixed on the first 30 readings' });
    createChart({ grid, container: '#mr', type: 'movingRange', y: 'bore', title: 'Moving range' });
    createChart({ grid, container: '#cap', type: 'capability', y: 'bore', title: 'Capability against the tolerance' });
  }
}

bootstrapApplication(AppComponent);

Lattice Grid Buy a licence

demo D230

An SPC study: control, range, capability

A drifting process with limits fixed on the first thirty readings, so the drift breaks a rule rather than being absorbed

chart type: control · movingRange · capability

Building…
Loading a live grid…

The configuration

<script>
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeAction from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/svelte.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/charts.esm.min.js';

  const lattice = createLatticeAction({ createGrid });

  let controlEl, mrEl, capEl;

  const config = {
    rowKey: 'id',
    columns: [
      { field: 'n', title: '#', type: 'number' },
      // The tolerance is declared once, on the column; every SPC figure reads it.
      { field: 'bore', title: 'Bore', type: 'millimetres', spec: { lower: 9.95, upper: 10.05, target: 10 } },
    ],
    rows,  // measured parts, in the order they were made
    // onGrid hands over the live grid the moment it is created. Every chart reads
    // it, so all three follow the grid's filters and sort.
    onGrid: (grid) => {
      // baseline fixes the limits on the first 30 readings, so a later drift breaks
      // a rule rather than widening the limits to absorb it.
      createChart({ grid, container: controlEl, type: 'control',     y: 'bore', baseline: 30, rules: 'nelson' });
      createChart({ grid, container: mrEl,      type: 'movingRange', y: 'bore' });
      createChart({ grid, container: capEl,     type: 'capability',  y: 'bore' });

      // The capability index against the declared tolerance, with the rule set applied.
      const c = grid.statistics.capability('bore', { rules: 'nelson', baseline: 30 });
      console.log(c.cpk, c.violations);
    },
  };
</script>

<svelte:head>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">
</svelte:head>

<div bind:this={controlEl} style="height: 220px"></div>
<div style="display: flex; gap: 12px; margin-top: 12px">
  <div bind:this={mrEl} style="flex: 1; height: 200px"></div>
  <div bind:this={capEl} style="flex: 1; height: 200px"></div>
</div>
<div use:lattice={config} style="height: 320px; margin-top: 12px"></div>